# cb_panel "Launcher" plugin

name = "ShowDesktop"
description = """ShowDesktop."""

import CBpanel, gtk, wnck

class Plugin(CBpanel.Plugin):
    def __init__(self, panel, settings):
        CBpanel.Plugin.__init__(self, panel, settings)
        self.set_border_width(0)

        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        btn.set_name("ShowDesktop")
        btn.connect("button-release-event", self.onClicked)
        self.add(btn)

        if settings.has_key('icon') and settings['icon'] != None and len(settings['icon'])>0:
            img = panel.get_image_from_file(settings['icon'])
        else:
            #~ img = panel.get_image_from_file('showdesktop.png')
            img = panel.get_image_from_icon_name('user-desktop')

        btn.add(img)
        self.show_all()

    def onClicked(self, widget, event):
        screen = wnck.screen_get_default()
        # showing windows = not showing desktop
        showing_windows = not screen.get_showing_desktop()
        screen.toggle_showing_desktop(showing_windows)
